Index: /events/src/test/java/geniusweb/actions/AcceptTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/AcceptTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/actions/AcceptTest.java	(revision 33)
@@ -36,5 +36,5 @@
 	private final static Value VALUE2 = new NumberValue("10");
 	// issue 2 is NUMBER and thus serializes with leading '='
-	private final String acceptstring = "{\"accept\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}}}}";
+	private final String acceptstring = "{\"Accept\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}}}}";
 
 	private static Accept accept, accept1, accept2, acceptb;
Index: /events/src/test/java/geniusweb/actions/EndNegoTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/EndNegoTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/actions/EndNegoTest.java	(revision 33)
@@ -24,5 +24,5 @@
 	private final EndNegotiation endnegob = new EndNegotiation(idb);
 
-	private final String endnegostring = "{\"endnegotiation\":{\"actor\":\"party1\"}}";
+	private final String endnegostring = "{\"EndNegotiation\":{\"actor\":\"party1\"}}";
 
 	@Override
Index: /events/src/test/java/geniusweb/actions/OfferTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/OfferTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/actions/OfferTest.java	(revision 33)
@@ -32,5 +32,5 @@
 	private static final String ISSUE2 = "issue2";
 	private static final Value VALUE2 = new NumberValue("10");
-	private static final String acceptstring = "{\"offer\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}}}}";
+	private static final String acceptstring = "{\"Offer\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}}}}";
 
 	private static Offer offer;
Index: /events/src/test/java/geniusweb/actions/VoteTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/VoteTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/actions/VoteTest.java	(revision 33)
@@ -35,5 +35,5 @@
 	private final static Value VALUE2 = new NumberValue("10");
 	// issue 2 is NUMBER and thus serializes with leading '='
-	private final String votestring = "{\"vote\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"minPower\":1,\"maxPower\":2}}";
+	private final String votestring = "{\"Vote\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"minPower\":1,\"maxPower\":2}}";
 
 	private static Vote vote1, vote1a, vote2, vote3, vote4, vote5;
Index: /events/src/test/java/geniusweb/actions/VoteWithValueTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/VoteWithValueTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/actions/VoteWithValueTest.java	(revision 33)
@@ -35,5 +35,5 @@
 	private final static Value VALUE2 = new NumberValue("10");
 	// issue 2 is NUMBER and thus serializes with leading '='
-	private final String votestring = "{\"votewithvalue\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"minPower\":1,\"maxPower\":2,\"value\":10}}";
+	private final String votestring = "{\"VoteWithValue\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"issue2\":10,\"issue1\":\"value1\"}},\"minPower\":1,\"maxPower\":2,\"value\":10}}";
 
 	private static VoteWithValue vote1, vote1a, vote2, vote3, vote4, vote5,
Index: /events/src/test/java/geniusweb/actions/VotesTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/VotesTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/actions/VotesTest.java	(revision 33)
@@ -22,5 +22,5 @@
 public class VotesTest extends GeneralTests<Votes> {
 	private final ObjectMapper jackson = new ObjectMapper();
-	private final String votestring = "{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val1\"}},\"minPower\":2,\"maxPower\":9}},{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val2\"}},\"minPower\":2,\"maxPower\":9}}]}}";
+	private final String votestring = "{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"Vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val1\"}},\"minPower\":2,\"maxPower\":9}},{\"Vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val2\"}},\"minPower\":2,\"maxPower\":9}}]}}";
 
 	private PartyId partyA = new PartyId("partyA");
Index: /events/src/test/java/geniusweb/actions/VotesWithValueTest.java
===================================================================
--- /events/src/test/java/geniusweb/actions/VotesWithValueTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/actions/VotesWithValueTest.java	(revision 33)
@@ -22,5 +22,5 @@
 public class VotesWithValueTest extends GeneralTests<VotesWithValue> {
 	private final ObjectMapper jackson = new ObjectMapper();
-	private final String votestring = "{\"VotesWithValue\":{\"actor\":\"partyA\",\"votes\":[{\"votewithvalue\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val1\"}},\"minPower\":2,\"maxPower\":9,\"value\":30}},{\"votewithvalue\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val2\"}},\"minPower\":2,\"maxPower\":9,\"value\":70}}]}}";
+	private final String votestring = "{\"VotesWithValue\":{\"actor\":\"partyA\",\"votes\":[{\"VoteWithValue\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val1\"}},\"minPower\":2,\"maxPower\":9,\"value\":30}},{\"VoteWithValue\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"is1\":\"val2\"}},\"minPower\":2,\"maxPower\":9,\"value\":70}}]}}";
 
 	private PartyId partyA = new PartyId("partyA");
Index: /events/src/test/java/geniusweb/events/ActionEventTest.java
===================================================================
--- /events/src/test/java/geniusweb/events/ActionEventTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/events/ActionEventTest.java	(revision 33)
@@ -21,5 +21,5 @@
 	private static final long NOW = 101l;
 	private final ObjectMapper jackson = new ObjectMapper();
-	private final String string = "{\"actionevent\":{\"action\":{\"endnegotiation\":{\"actor\":\"party1\"}},\"time\":101}}";
+	private final String string = "{\"ActionEvent\":{\"action\":{\"EndNegotiation\":{\"actor\":\"party1\"}},\"time\":101}}";
 	private final PartyId id = new PartyId("party1");
 	private final Action action = new EndNegotiation(id);
Index: /events/src/test/java/geniusweb/events/SessionStartedTest.java
===================================================================
--- /events/src/test/java/geniusweb/events/SessionStartedTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/events/SessionStartedTest.java	(revision 33)
@@ -41,5 +41,5 @@
 			SESSIONNR, parties, NOW);
 	// jackson expected format.
-	private static String sessionstartedstring = "{\"sessionstarted\":{\"sessionNumber\":1,\"parties\":[\"party1\",\"party2\"],\"time\":101}}";
+	private static String sessionstartedstring = "{\"SessionStarted\":{\"sessionNumber\":1,\"parties\":[\"party1\",\"party2\"],\"time\":101}}";
 	// "{\"sessionstarted\":{\"time\":101,\"sessionNumber\":1,\"parties\":[\"party1\",\"party2\"]}}";
 	public static String expectedstring = "SessionStarted.*101.*";
Index: /events/src/test/java/geniusweb/events/TournamentStartedTest.java
===================================================================
--- /events/src/test/java/geniusweb/events/TournamentStartedTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/events/TournamentStartedTest.java	(revision 33)
@@ -33,5 +33,5 @@
 			NSESSIONS, NOW1);
 
-	private String tournamentstartedstring = "{\"tournamentstarted\":{\"time\":101,\"numberOfSessions\":5}}";
+	private String tournamentstartedstring = "{\"TournamentStarted\":{\"time\":101,\"numberOfSessions\":5}}";
 
 	@Override
Index: /events/src/test/java/geniusweb/inform/ActionDoneTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/ActionDoneTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/inform/ActionDoneTest.java	(revision 33)
@@ -24,5 +24,5 @@
 	private static final PartyId id2 = new PartyId("party2");
 
-	private final String actiondonestr = "{\"ActionDone\":{\"action\":{\"endnegotiation\":{\"actor\":\"party1\"}}}}";
+	private final String actiondonestr = "{\"ActionDone\":{\"action\":{\"EndNegotiation\":{\"actor\":\"party1\"}}}}";
 
 	private final static Action act1 = new EndNegotiation(id);
Index: /events/src/test/java/geniusweb/inform/OptInTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/OptInTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/inform/OptInTest.java	(revision 33)
@@ -42,5 +42,5 @@
 	private final OptIn optIn2 = new OptIn(Arrays.asList(votesA));
 
-	private String asJson = "{\"OptIn\":{\"votes\":[{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9}}]}},{\"Votes\":{\"actor\":\"partyB\",\"votes\":[{\"vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val2\"}},\"minPower\":2,\"maxPower\":9}},{\"vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9}}]}}]}}";
+	private String asJson = "{\"OptIn\":{\"votes\":[{\"Votes\":{\"actor\":\"partyA\",\"votes\":[{\"Vote\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9}}]}},{\"Votes\":{\"actor\":\"partyB\",\"votes\":[{\"Vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val2\"}},\"minPower\":2,\"maxPower\":9}},{\"Vote\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9}}]}}]}}";
 
 	@Override
Index: /events/src/test/java/geniusweb/inform/OptInWithValueTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/OptInWithValueTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/inform/OptInWithValueTest.java	(revision 33)
@@ -49,5 +49,5 @@
 			Arrays.asList(votesA));
 
-	private String asJson = "{\"OptInWithValue\":{\"votes\":[{\"VotesWithValue\":{\"actor\":\"partyA\",\"votes\":[{\"votewithvalue\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9,\"value\":100}}]}},{\"VotesWithValue\":{\"actor\":\"partyB\",\"votes\":[{\"votewithvalue\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9,\"value\":60}},{\"votewithvalue\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val2\"}},\"minPower\":2,\"maxPower\":9,\"value\":40}}]}}]}}";
+	private String asJson = "{\"OptInWithValue\":{\"votes\":[{\"VotesWithValue\":{\"actor\":\"partyA\",\"votes\":[{\"VoteWithValue\":{\"actor\":\"partyA\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9,\"value\":100}}]}},{\"VotesWithValue\":{\"actor\":\"partyB\",\"votes\":[{\"VoteWithValue\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}},\"minPower\":2,\"maxPower\":9,\"value\":60}},{\"VoteWithValue\":{\"actor\":\"partyB\",\"bid\":{\"issuevalues\":{\"iss\":\"val2\"}},\"minPower\":2,\"maxPower\":9,\"value\":40}}]}}]}}";
 
 	@Override
Index: /events/src/test/java/geniusweb/inform/SettingsTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/SettingsTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/inform/SettingsTest.java	(revision 33)
@@ -36,5 +36,5 @@
 			+ "{\"id\":\"party1\",\"profile\":\"ws:profile1\","
 			+ "\"protocol\":\"ws:localhost/protocol1\","
-			+ "\"progress\":{\"rounds\":{\"duration\":10,\"currentRound\":0,\"endtime\":999}},"
+			+ "\"progress\":{\"ProgressRounds\":{\"duration\":10,\"currentRound\":0,\"endtime\":999}},"
 			+ "\"parameters\":{}}}";
 
Index: /events/src/test/java/geniusweb/inform/VotingTest.java
===================================================================
--- /events/src/test/java/geniusweb/inform/VotingTest.java	(revision 32)
+++ /events/src/test/java/geniusweb/inform/VotingTest.java	(revision 33)
@@ -40,5 +40,5 @@
 			Arrays.asList(new Offer(party1, bid1)), powers2);
 
-	private String asJson = "{\"Voting\":{\"offers\":[{\"offer\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}}}}],\"powers\":{\"party1\":2}}}";
+	private String asJson = "{\"Voting\":{\"offers\":[{\"Offer\":{\"actor\":\"party1\",\"bid\":{\"issuevalues\":{\"iss\":\"val1\"}}}}],\"powers\":{\"party1\":2}}}";
 
 	@Override
Index: /exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java
===================================================================
--- /exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 32)
+++ /exampleparties/anac2019/agentgg/src/main/java/geniusweb/exampleparties/agentgg/AgentGG.java	(revision 33)
@@ -100,4 +100,5 @@
 			} else if (info instanceof Finished) {
 				getReporter().log(Level.INFO, "Final ourcome:" + info);
+				terminate(); // stop this party and free resources.
 			}
 		} catch (Exception e) {
Index: /exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java
===================================================================
--- /exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 32)
+++ /exampleparties/anac2019/winkyagent/src/main/java/geniusweb/exampleparties/anac2019/winkyagent/WinkyAgent.java	(revision 33)
@@ -100,4 +100,5 @@
 			} else if (info instanceof Finished) {
 				getReporter().log(Level.INFO, "Final ourcome:" + info);
+				terminate(); // stop this party and free resources.
 			}
 		} catch (Exception e) {
Index: /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java
===================================================================
--- /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 32)
+++ /exampleparties/comparebids/src/main/java/geniusweb/exampleparties/comparebids/CompareBids.java	(revision 33)
@@ -57,4 +57,5 @@
 				}
 			} else if (info instanceof Finished) {
+				terminate(); // stop this party and free resources.
 			} else {
 				reporter.log(Level.WARNING, "COB party ignores " + info);
Index: /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java
===================================================================
--- /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 32)
+++ /exampleparties/randomparty/src/main/java/geniusweb/exampleparties/randomparty/RandomParty.java	(revision 33)
@@ -85,14 +85,14 @@
 		try {
 			if (info instanceof Settings) {
-				Settings settings = (Settings) info;
-				this.me = settings.getID();
-				this.progress = settings.getProgress();
-				this.settings = settings;
-				this.protocol = settings.getProtocol().getURI().getPath();
+				Settings sett = (Settings) info;
+				this.me = sett.getID();
+				this.progress = sett.getProgress();
+				this.settings = sett;
+				this.protocol = sett.getProtocol().getURI().getPath();
 				if ("Learn".equals(protocol)) {
 					getConnection().send(new LearningDone(me));
 				} else {
 					this.profileint = ProfileConnectionFactory.create(
-							settings.getProfile().getURI(), getReporter());
+							sett.getProfile().getURI(), getReporter());
 				}
 			} else if (info instanceof ActionDone) {
@@ -130,6 +130,6 @@
 	@Override
 	public Capabilities getCapabilities() {
-		return new Capabilities(
-				new HashSet<>(Arrays.asList("SAOP", "AMOP", "MOPAC", "MOPAC2")),
+		return new Capabilities(new HashSet<>(
+				Arrays.asList("SAOP", "AMOP", "MOPAC", "MOPAC2", "Learn")),
 				Collections.singleton(Profile.class));
 	}
Index: /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java
===================================================================
--- /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 32)
+++ /exampleparties/simpleshaop/src/main/java/geniusweb/exampleparties/simpleshaop/ShaopParty.java	(revision 33)
@@ -84,4 +84,5 @@
 			} else if (info instanceof Finished) {
 				getReporter().log(Level.INFO, "Final ourcome:" + info);
+				terminate(); // stop this party and free resources.
 			}
 		} catch (Exception e) {
Index: /issuevalue/src/main/java/geniusweb/issuevalue/DiscreteValueSet.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/DiscreteValueSet.java	(revision 32)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/DiscreteValueSet.java	(revision 33)
@@ -11,5 +11,4 @@
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
-import com.fasterxml.jackson.annotation.JsonTypeName;
 import com.fasterxml.jackson.databind.JsonDeserializer;
 import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
@@ -20,5 +19,4 @@
  * set of discrete values
  */
-@JsonTypeName("discreteset")
 // disable the inherited deserializer to prevent getting into infinite loop...
 @JsonDeserialize(using = JsonDeserializer.None.class)
Index: /issuevalue/src/main/java/geniusweb/issuevalue/Domain.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/Domain.java	(revision 32)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/Domain.java	(revision 33)
@@ -12,7 +12,5 @@
 
 /**
- * A dmain description. Two domains are equal if they have the same issues in
- * the same order.
- *
+ * A dmain description.
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
@@ -27,5 +25,6 @@
 	 * @param shortName a short name for display/toString. This name must
 	 *                  contain simple characters only (a-z, A-Z, 0-9).
-	 * @param issues    the issues, list because order may be important.
+	 * @param issues    the issues, Map with key: the issue name and value:
+	 *                  {@link ValueSet} with the allowed values for the issue.
 	 */
 	@JsonCreator
Index: /issuevalue/src/main/java/geniusweb/issuevalue/NumberValue.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/NumberValue.java	(revision 32)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/NumberValue.java	(revision 33)
@@ -50,5 +50,6 @@
 			if (other.value != null)
 				return false;
-		} else if (!value.equals(other.value))
+		} else if (value.compareTo(other.value) != 0)
+			// MANUAL FIX, DO NOT USE value.equals
 			return false;
 		return true;
Index: /issuevalue/src/main/java/geniusweb/issuevalue/NumberValueSet.java
===================================================================
--- /issuevalue/src/main/java/geniusweb/issuevalue/NumberValueSet.java	(revision 32)
+++ /issuevalue/src/main/java/geniusweb/issuevalue/NumberValueSet.java	(revision 33)
@@ -9,5 +9,4 @@
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
-import com.fasterxml.jackson.annotation.JsonTypeName;
 import com.fasterxml.jackson.databind.JsonDeserializer;
 import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
@@ -18,5 +17,4 @@
  * number range from low to high with given step size
  */
-@JsonTypeName("numberset")
 // disable the inherited deserializer to prevent getting into infinite loop...
 @JsonDeserialize(using = JsonDeserializer.None.class)
Index: /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueSetTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueSetTest.java	(revision 32)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/DiscreteValueSetTest.java	(revision 33)
@@ -19,7 +19,4 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
-import geniusweb.issuevalue.DiscreteValue;
-import geniusweb.issuevalue.DiscreteValueSet;
-
 public class DiscreteValueSetTest {
 
@@ -35,5 +32,6 @@
 			valuesReverse);
 	private static final String asString = "{\"values\":[\"a\",\"b\"]}";
-	// private static final String asString = "{\"discreteset\":[\"a\",\"b\"]}";
+	// private static final String asString = "{\"DiscreteValueSet
+	// \":[\"a\",\"b\"]}";
 	private static final String asString1 = "[\"a\",\"b\"]";
 
Index: /issuevalue/src/test/java/geniusweb/issuevalue/DomainTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/DomainTest.java	(revision 32)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/DomainTest.java	(revision 33)
@@ -36,5 +36,5 @@
 	private static final String ISSUE3 = "issue3";
 	private static final ObjectMapper jackson = new ObjectMapper();
-	private static final String domainstring = "{\"name\":\"testdomain\",\"issuesValues\":{\"issue2\":{\"range\":[2,3,0.22]},\"issue1\":{\"values\":[\"i1v1\",\"i1v2\"]}}}";
+	private static final String domainstring = "{\"name\":\"testdomain\",\"issuesValues\":{\"issue2\":{\"range\":{\"low\":2,\"high\":3,\"step\":0.22}},\"issue1\":{\"values\":[\"i1v1\",\"i1v2\"]}}}";
 
 	private static final String jobsstring = "{\"name\":\"jobs\","
Index: /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueSetTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueSetTest.java	(revision 32)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueSetTest.java	(revision 33)
@@ -23,14 +23,16 @@
 	private static final BigDecimal TWELVE_SIX = new BigDecimal("12.6");
 	private static final BigDecimal TWELVE_TWO = new BigDecimal("12.2");
-	private final static NumberValueSet set = new NumberValueSet(TWELVE_TWO, TWELVE_SIX, ZERO_THREE);
-	private final static NumberValueSet set1 = new NumberValueSet(TWELVE_TWO, TWELVE_SIX, ZERO_THREE);
-	private final static NumberValueSet setb = new NumberValueSet(TWELVE_TWO, new BigDecimal("12.6000000000001"),
-			ZERO_THREE);
-	private final static NumberValueSet set10 = new NumberValueSet(BigDecimal.ZERO, BigDecimal.ONE,
-			new BigDecimal("0.1"));
+	private final static NumberValueSet set = new NumberValueSet(TWELVE_TWO,
+			TWELVE_SIX, ZERO_THREE);
+	private final static NumberValueSet set1 = new NumberValueSet(TWELVE_TWO,
+			TWELVE_SIX, ZERO_THREE);
+	private final static NumberValueSet setb = new NumberValueSet(TWELVE_TWO,
+			new BigDecimal("12.6000000000001"), ZERO_THREE);
+	private final static NumberValueSet set10 = new NumberValueSet(
+			BigDecimal.ZERO, BigDecimal.ONE, new BigDecimal("0.1"));
 
-	private final String asString = "{\"range\":[12.2,12.6,0.3]}";
-	private final static NumberValueSet bigset = new NumberValueSet(BigDecimal.ZERO, BigDecimal.TEN,
-			new BigDecimal("0.00003"));
+	private final String asString = "{\"range\":{\"low\":12.2,\"high\":12.6,\"step\":0.3}}";
+	private final static NumberValueSet bigset = new NumberValueSet(
+			BigDecimal.ZERO, BigDecimal.TEN, new BigDecimal("0.00003"));
 
 	@Test(expected = IllegalArgumentException.class)
@@ -41,10 +43,12 @@
 	@Test(expected = IllegalArgumentException.class)
 	public void testConstructor2() {
-		new NumberValueSet(BigDecimal.ZERO, BigDecimal.TEN, new BigDecimal("-1"));
+		new NumberValueSet(BigDecimal.ZERO, BigDecimal.TEN,
+				new BigDecimal("-1"));
 	}
 
 	@Test
 	public void testIterator() {
-		assertEquals(new NumberValue(BigDecimal.ZERO), bigset.iterator().next());
+		assertEquals(new NumberValue(BigDecimal.ZERO),
+				bigset.iterator().next());
 	}
 
@@ -59,5 +63,6 @@
 
 	@Test
-	public void testDeserialize() throws JsonParseException, JsonMappingException, IOException {
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
 		ObjectMapper jackson = new ObjectMapper();
 		ValueSet p = jackson.readValue(asString, NumberValueSet.class);
@@ -92,5 +97,6 @@
 	@Test
 	public void getRangeTest() {
-		assertEquals(new Range(TWELVE_TWO, TWELVE_SIX, ZERO_THREE), set.getRange());
+		assertEquals(new Range(TWELVE_TWO, TWELVE_SIX, ZERO_THREE),
+				set.getRange());
 	}
 
@@ -99,5 +105,6 @@
 		assertEquals(new NumberValue(TWELVE_TWO), set.get(BigInteger.ZERO));
 		assertEquals(new NumberValue(TWELVE_TWO), set.get(0));
-		assertEquals(new NumberValue(TWELVE_TWO.add(ZERO_THREE)), set.get(BigInteger.ONE));
+		assertEquals(new NumberValue(TWELVE_TWO.add(ZERO_THREE)),
+				set.get(BigInteger.ONE));
 	}
 
Index: /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java
===================================================================
--- /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java	(revision 32)
+++ /issuevalue/src/test/java/geniusweb/issuevalue/NumberValueTest.java	(revision 33)
@@ -126,3 +126,13 @@
 	}
 
+	@Test
+	public void testDeserializeScientificNotation()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		String valstr = "9E+2";
+		Value val = jackson.readValue(valstr, Value.class);
+		assertEquals(valstr, val.toString());
+		assertEquals(val, new NumberValue(new BigDecimal("900")));
+	}
+
 }
Index: /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 32)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilities.java	(revision 33)
@@ -9,5 +9,4 @@
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
 import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
-import com.fasterxml.jackson.annotation.JsonTypeName;
 
 import geniusweb.issuevalue.DiscreteValue;
@@ -25,5 +24,4 @@
  * </ul>
  */
-@JsonTypeName("discreteutils")
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
 public class DiscreteValueSetUtilities implements ValueSetUtilities {
Index: /profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java	(revision 32)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/NumberValueSetUtilities.java	(revision 33)
@@ -8,5 +8,4 @@
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
-import com.fasterxml.jackson.annotation.JsonTypeName;
 
 import geniusweb.issuevalue.NumberValue;
@@ -21,5 +20,4 @@
  *
  */
-@JsonTypeName("numberutils")
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
 public class NumberValueSetUtilities implements ValueSetUtilities {
Index: /profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java
===================================================================
--- /profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java	(revision 32)
+++ /profile/src/main/java/geniusweb/profile/utilityspace/PartsUtilities.java	(revision 33)
@@ -12,5 +12,4 @@
 import com.fasterxml.jackson.annotation.JsonCreator;
 import com.fasterxml.jackson.annotation.JsonProperty;
-import com.fasterxml.jackson.annotation.JsonTypeName;
 
 import geniusweb.issuevalue.Value;
@@ -31,5 +30,4 @@
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
-@JsonTypeName("partsutils")
 public class PartsUtilities implements ValueSetUtilities {
 	private final List<String> issues;
Index: /profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java
===================================================================
--- /profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java	(revision 32)
+++ /profile/src/test/java/geniusweb/profile/utilityspace/DiscreteValueSetUtilitiesTest.java	(revision 33)
@@ -199,5 +199,5 @@
 		// Notice, party tent has extra single quote in the valuesstr.
 		String valuesstr = "{\"values\": [\"Party Tent'\",\"Your Dorm\", \"Party Room\", \"Ballroom\" ]}";
-		String utilstring = "{\"discreteutils\": {\"valueUtilities\": {\"Party Tent\": 0.52,\"Your Dorm\": 0.23,\"Party Room\": 0.99,\"Ballroom\": 0.77}}}";
+		String utilstring = "{\"DiscreteValueSetUtilities\": {\"valueUtilities\": {\"Party Tent\": 0.52,\"Your Dorm\": 0.23,\"Party Room\": 0.99,\"Ballroom\": 0.77}}}";
 		ValueSetUtilities valueutils = jackson.readValue(utilstring,
 				ValueSetUtilities.class);
@@ -213,5 +213,5 @@
 		// Check that DiscreteValueSetUtilities properly deserializes
 		// discreteutils.
-		String utilstring = "{\"discreteutils\": {\"valueUtilities\": {\"Party Tent\": 0.52,\"Your Dorm\": 0.23,\"Party Room\": 0.99,\"Ballroom\": 0.77}}}";
+		String utilstring = "{\"DiscreteValueSetUtilities\": {\"valueUtilities\": {\"Party Tent\": 0.52,\"Your Dorm\": 0.23,\"Party Room\": 0.99,\"Ballroom\": 0.77}}}";
 		DiscreteValueSetUtilities valueutils = jackson.readValue(utilstring,
 				DiscreteValueSetUtilities.class);
